import os
import numpy as np
from sklearn.feature_extraction.text import CountVectorizer

def malware(path='log_files'):
    labels = []
    text = []

    for filename in os.listdir(path):
        if "Good" in filename:
            labels.append("1")
        else:
            labels.append("-1")
        filename = os.path.join(path, filename)
        with open(filename, encoding="utf-8") as f:
            content = f.read()
        content.replace(",", " ")
        content.replace('"', " ")
        text.append(content)

    vectorizer = CountVectorizer(stop_words='english', max_features=1000)
    dtm = vectorizer.fit_transform(text)

    # Convert the Document-Term Matrix to a numpy array
    dtm_array = dtm.toarray()

    # Convert the labels list to a numpy array and reshape it to match the number of rows in dtm_array
    labels_array = np.array(labels).reshape(-1, 1)

    # Concatenate the labels_array and dtm_array along the second axis (columns)
    data = np.concatenate((labels_array, dtm_array), axis=1)

    return data, vectorizer.get_feature_names()

if __name__ == "__main__":
    data, features = malware()
    for feature in features:
        print(str(feature))